             #include <p12f675.inc>
             LIST        p=12F675    ;   .
            __CONFIG    03F8CH 


Sec         equ         20h
Sec0        equ         21h
Sec1        equ         22h
var         equ         23h
vremen      equ         24h
predid      equ         25h
chislo      equ         26h
code1       equ         27h
code2       equ         28h
code3       equ         2Ah
code4       equ         2Bh
pozicia     equ         2Ch
newcode1    equ         2Dh
newcode2    equ         2Eh
newcode3    equ         2Fh
newcode4    equ         30h
shet        equ         31h
shet1       equ         32h
Sec3        equ         33h
code5       equ         34h
newcode5    equ         35h
Sec4        equ         36h


#define    goacp       ADCON0,1
#define    beep        GPIO,4
#define    open        GPIO,5
#define    LED         GPIO,1
#define    LED1        GPIO,2


           


            org         0           ;      0 PC.
            goto        Start       ;    Start.
        
Start       clrwdt
            bsf         STATUS,RP0
            movlw       b'11111111'
            movwf       OPTION_REG
            movlw       b'01010001'
            movwf       ANSEL
            bcf         STATUS,RP0
            movlw       b'00000111'
            movwf       CMCON
            movlw       b'00000100'
            movwf       GPIO
            bsf         STATUS,RP0
            movlw       b'00000001'
            movwf       TRISIO
            bcf         STATUS,RP0
            movlw       b'00000001'
            movwf       ADCON0
            bsf         STATUS,RP0
            call        3FFh
            movwf       OSCCAL
            bcf         STATUS,RP0

           movlw       .0
           movwf       chislo           
           goto        s1
met7       call        tone
s1         call        Pause
           call        izm
           xorlw       .0
           btfss       STATUS,Z
           goto        s1
           movf        predid,W
           xorlw       .0
           btfsc       STATUS,Z
           goto        s1

           bsf         LED
           call        highton
           bcf         LED

           call        pause1
           call        izm         ;  1-   
           xorlw       .0
           btfsc       STATUS,Z
           goto        s1
           movf        chislo,W
           movwf       code1

           bsf         LED
           call        highton03
           bcf         LED

           call        pause1
           call        izm        ;  2-   
           xorlw       .0
           btfsc       STATUS,Z
           goto        met7
           movf        chislo,W
           movwf       code2
           bsf         LED
           call        highton03
           bcf         LED
           call        pause1 
           call        izm         ;  3-   
           xorlw       .0
           btfsc       STATUS,Z
           goto        met7
           movf        chislo,W
           movwf       code3
           bsf         LED
           call        highton03
           bcf         LED
           call        pause1 
           call        izm         ;  4-   
           xorlw       .0
           btfsc       STATUS,Z
           goto        met7
           movf        chislo,W
           movwf       code4
           bsf         LED
           call        highton03
           bcf         LED
           call        pause1 
           call        izm         ;  5-   
           xorlw       .0
           btfsc       STATUS,Z
           goto        met7
           movf        chislo,W
           movwf       code5
           bsf         LED
           call        highton03
           bcf         LED
           call        Pause 
           
provsmen   bsf         STATUS,RP0      ;    2                      

       
           movlw       0x05            
           movwf       EEADR
           bsf         EECON1,RD
met27      btfsc       EECON1,RD
           goto        met27
           movf        EEDATA,W
           xorwf       code1,W
           btfss       STATUS,Z
           goto        proverka

           movlw       0x06
           movwf       EEADR
           bsf         EECON1,RD
met28      btfsc       EECON1,RD
           goto        met28
           movf        EEDATA,W
           xorwf       code2,W
           btfss       STATUS,Z
           goto        proverka

           movlw       0x07
           movwf       EEADR
           bsf         EECON1,RD
met29      btfsc       EECON1,RD
           goto        met29
           movf        EEDATA,W
           xorwf       code3,W
           btfss       STATUS,Z
           goto        proverka

           movlw       0x08
           movwf       EEADR
           bsf         EECON1,RD
met30      btfsc       EECON1,RD
           goto        met30
           movf        EEDATA,W
           xorwf       code4,W
           btfss       STATUS,Z
           goto        proverka
           
                 
           movlw       0x09
           movwf       EEADR
           bsf         EECON1,RD
met31      btfsc       EECON1,RD
           goto        met31
           movf        EEDATA,W
           xorwf       code5,W
           btfss       STATUS,Z
           goto        proverka
           bcf         STATUS,RP0           

           movlw       .3
           movwf       var
m3         call        paus03
           bsf         LED          ;   
           call        highton03
           bcf         LED                  
           decfsz      var,F
           goto        m3

           call        pause1
           call        izm         ;  1-  
           xorlw       .0
           btfsc       STATUS,Z
           goto        met7
           movf        chislo,W
           movwf       newcode1     ; 1-      
           bsf         LED
           call        highton03
           bcf         LED
           call        pause1
           call        izm        ;  2-  
           xorlw       .0
           btfsc       STATUS,Z
           goto        met7
           movf        chislo,W
           movwf       newcode2     ; 2-       
           bsf         LED
           call        highton03
           bcf         LED
           call        pause1
           call        izm          ;  3-  
           xorlw       .0
           btfsc       STATUS,Z
           goto        met7
           movf        chislo,W
           movwf       newcode3     ; 3-       
           bsf         LED
           call        highton03
           bcf         LED
           call        pause1
           call        izm          ;  4-    
           xorlw       .0
           btfsc       STATUS,Z
           goto        met7
           movf        chislo,W
           movwf       newcode4     ; 4-       
           bsf         LED
           call        highton03
           bcf         LED
           call        pause1
           call        izm          ;  5-    
           xorlw       .0
           btfsc       STATUS,Z
           goto        met7
           movf        chislo,W
           movwf       newcode5     ; 5-       
           bsf         LED
           call        highton03
           bcf         LED
           call        Pause
              


writeEEP   movlw       .3          ; 1-    EEPROM,   
           movwf       shet1       ; 
           bsf         STATUS,RP0
           movlw       0x00
           movwf       EEADR
met12      movf        newcode1,W
           movwf       EEDATA
           call        write
           movf        EEDATA,W
           bsf         EECON1,RD
met10      btfsc       EECON1,RD
           goto        met10
           xorwf       EEDATA,W
           btfsc       STATUS,Z
           goto        met11
           decfsz      shet1,F
           goto        met12
           goto        ERREEP

met11      movlw       .3         ; 2-    EEPROM,  
           movwf       shet1      ; 
           movlw       0x01
           movwf       EEADR
met13      movf        newcode2,W
           movwf       EEDATA
           call        write
           movf        EEDATA,W
           bsf         EECON1,RD
met14      btfsc       EECON1,RD
           goto        met14
           xorwf       EEDATA,W
           btfsc       STATUS,Z
           goto        met15
           decfsz      shet1,F
           goto        met13
           goto        ERREEP

met15      movlw       .3       ; 3-    EEPROM,  
           movwf       shet1    ; 
           movlw       0x02
           movwf       EEADR
met16      movf        newcode3,W
           movwf       EEDATA
           call        write
           movf        EEDATA,W
           bsf         EECON1,RD
met17      btfsc       EECON1,RD
           goto        met17
           xorwf       EEDATA,W
           btfsc       STATUS,Z
           goto        met18
           decfsz      shet1,F
           goto        met16
           goto        ERREEP

met18      movlw       .3           ; 4-    EEPROM,  
           movwf       shet1        ; 
           movlw       0x03
           movwf       EEADR
met19      movf        newcode4,W
           movwf       EEDATA
           call        write
           movf        EEDATA,W
           bsf         EECON1,RD
met20      btfsc       EECON1,RD
           goto        met20
           xorwf       EEDATA,W
           btfsc       STATUS,Z
           goto        met33
           decfsz      shet1,F
           goto        met19
           goto        ERREEP

met33      movlw       .3           ; 5-    EEPROM,  
           movwf       shet1        ; 
           movlw       0x04
           movwf       EEADR
met34      movf        newcode5,W
           movwf       EEDATA
           call        write
           movf        EEDATA,W
           bsf         EECON1,RD
met35      btfsc       EECON1,RD
           goto        met35
           xorwf       EEDATA,W
           btfsc       STATUS,Z
           goto        met36
           decfsz      shet1,F
           goto        met34
           goto        ERREEP

met36      bcf         STATUS,RP0
           
           bsf         LED
           call        highton
           bcf         LED
           call        Pause
           bsf         LED
           call        highton
           bcf         LED
           goto        s1

write      movlw       .3
           movwf       shet
met9       bsf         EECON1,WREN
           movlw       055h
           movwf       EECON2
           movlw       0AAh
           movwf       EECON2
           bsf         EECON1,WR
met8       btfsc       EECON1,WR
           goto        met8
           bcf         EECON1,WREN
           btfss       EECON1,WRERR
           return
           decfsz      shet,F
           goto        met9
           return

ERREEP     bcf         STATUS,RP0
           bcf         LED1
           call        lowton
           bsf         LED1
           call        Pause
           bcf         LED1
           call        lowton
           bsf         LED1
           goto        s1


proverka   bsf         STATUS,RP0
           movlw       0x00
           movwf       EEADR
           bsf         EECON1,RD
met22      btfsc       EECON1,RD
           goto        met22
           movf        EEDATA,W
           xorwf       code1,W
           btfss       STATUS,Z
           goto        ERRCODE

           movlw       0x01
           movwf       EEADR
           bsf         EECON1,RD
met23      btfsc       EECON1,RD
           goto        met23
           movf        EEDATA,W
           xorwf       code2,W
           btfss       STATUS,Z
           goto        ERRCODE

           movlw       0x02
           movwf       EEADR
           bsf         EECON1,RD
met24      btfsc       EECON1,RD
           goto        met24
           movf        EEDATA,W
           xorwf       code3,W
           btfss       STATUS,Z
           goto        ERRCODE

           movlw       0x03
           movwf       EEADR
           bsf         EECON1,RD
met25      btfsc       EECON1,RD
           goto        met25
           movf        EEDATA,W
           xorwf       code4,W
           btfss       STATUS,Z
           goto        ERRCODE

           movlw       0x04
           movwf       EEADR
           bsf         EECON1,RD
met37      btfsc       EECON1,RD
           goto        met37
           movf        EEDATA,W
           xorwf       code5,W
           btfss       STATUS,Z
           goto        ERRCODE

           bcf         STATUS,RP0
           bsf         open
           bcf         LED1
           bsf         LED
           call        highton3
           bcf         LED
           bsf         LED1
           bcf         open
           goto        s1


ERRCODE    bcf         STATUS,RP0
           bcf         LED1
           call        lowton
           bsf         LED1
           goto        s1


izm        movf        chislo,W
           movwf       predid
           bsf         goacp
pov        btfsc       goacp
           goto        pov
           movf        ADRESH,W
           movwf       vremen
           sublw       .31
           btfss       STATUS,C
           goto        met1
           movlw       .0
           movwf       chislo
           return
met1       movf        vremen,W
           sublw       .63
           btfss       STATUS,C
           goto        met2
           movlw       .1
           movwf       chislo
           return
met2       movf        vremen,W
           sublw       .95
           btfss       STATUS,C
           goto        met3
           movlw       .2
           movwf       chislo
           return
met3       movf        vremen,W
           sublw       .127
           btfss       STATUS,C
           goto        met4
           movlw       .3
           movwf       chislo
           return
met4       movf        vremen,W
           sublw       .159
           btfss       STATUS,C
           goto        met5
           movlw       .4
           movwf       chislo
           return
met5       movf        vremen,W
           sublw       .191
           btfss       STATUS,C
           goto        met6
           movlw       .5
           movwf       chislo
           return
met6       movf        vremen,W
           sublw       .223
           btfss       STATUS,C
           goto        metk7
           movlw       .6
           movwf       chislo
           return
metk7      movlw       .7
           movwf       chislo
           return



                                
           
lowton     movlw       .2        
           movwf       Sec0
metka1     movlw       .255
           movwf       Sec
metka2     bsf         beep
           call        paus10
           bcf         beep
           call        paus10
           decfsz      Sec,F
           goto        metka2
           decfsz      Sec0,F
           goto        metka1
           return

tone       movlw       .130
           movwf       Sec
metk2      bsf         beep
           call        paus10
           bcf         beep
           call        paus10
           clrwdt
           decfsz      Sec,F
           goto        metk2
           return



highton03  movlw       .6       
           goto        metka5
highton    movlw       .20       
metka5     movwf       Sec0
metka3     clrwdt
           movlw       .255
           movwf       Sec
metka4     bsf         beep
           call        paus50
           bcf         beep
           call        paus50
           decfsz      Sec,F
           goto        metka4
           decfsz      Sec0,F
           goto        metka3
           return



paus50      movlw       .35
            movwf       Sec1
m1          decfsz      Sec1,F
            goto        m1
            return

paus10      movlw       .4
            movwf       Sec3
a3          decfsz      Sec3,F
            goto        a1
            return 
a1          movlw       .110
            movwf       Sec1
a2          decfsz      Sec1,F
            goto        a2
            goto        a3



paus03      movlw       .3
            goto        Paus
Pause       movlw       .7
Paus        movwf       Sec
Psvet       decfsz      Sec,F
            goto        Paus1
            Return
Paus1       clrwdt
            movlw       .100
            movwf       Sec0
P11         decfsz      Sec0,F
            goto        Paus2
            goto        Psvet    
Paus2       movlw       .255
            movwf       Sec1
P22         decfsz      Sec1,F
            goto        P22
            goto        P11 



pause1     bsf         STATUS,RP0
           movlw       .10          
           movwf       EEADR
           bsf         EECON1,RD
met38      btfsc       EECON1,RD
           goto        met38
           movf        EEDATA,W
           xorlw       .1
           btfss       STATUS,Z
           goto        m4
           movlw       .6
           goto        Pse
m4         movf        EEDATA,W
           xorlw       .2
           btfss       STATUS,Z
           goto        m5
           movlw       .11
           goto        Pse               
m5         movf        EEDATA,W
           xorlw       .3
           btfss       STATUS,Z
           goto        m6
           movlw       .16
           goto        Pse
m6         movf        EEDATA,W
           xorlw       .4
           btfss       STATUS,Z
           goto        m7
           movlw       .21
           goto        Pse
m7         movf        EEDATA,W
           xorlw       .5
           btfss       STATUS,Z
           goto        m13
           movlw       .27
           goto        Pse


m13         movlw       .12           
Pse         movwf       Sec
            bcf         STATUS,RP0
Psv         decfsz      Sec,F
            goto        Pas1
            Return
Pas1        clrwdt
            movlw       .255
            movwf       Sec0
P33         decfsz      Sec0,F
            goto        Pas2
            goto        Psv    
Pas2       movlw       .255
            movwf       Sec1
P44         decfsz      Sec1,F
            goto        P44
            goto        P33 


highton3   bsf         STATUS,RP0
           movlw       .11           
           movwf       EEADR
           bsf         EECON1,RD
met50      btfsc       EECON1,RD
           goto        met50
           movf        EEDATA,W
           xorlw       .1
           btfss       STATUS,Z
           goto        m14
           movlw       .1
           goto        Pss
m14        movf        EEDATA,W
           xorlw       .2
           btfss       STATUS,Z
           goto        m15
           movlw       .2
           goto        Pss               
m15        movf        EEDATA,W
           xorlw       .3
           btfss       STATUS,Z
           goto        m16
           movlw       .3
           goto        Pss
m16        movf        EEDATA,W
           xorlw       .4
           btfss       STATUS,Z
           goto        m17
           movlw       .4
           goto        Pss
m17        movf        EEDATA,W
           xorlw       .5
           btfss       STATUS,Z
           goto        m18
           movlw       .5
           goto        Pss
m18        movf        EEDATA,W
           xorlw       .6
           btfss       STATUS,Z
           goto        m19
           movlw       .6
           goto        Pss
m19        movf        EEDATA,W
           xorlw       .7
           btfss       STATUS,Z
           goto        m20
           movlw       .7
           goto        Pss
m20        movf        EEDATA,W
           xorlw       .8
           btfss       STATUS,Z
           goto        m21
           movlw       .8
           goto        Pss
m21        movf        EEDATA,W
           xorlw       .9
           btfss       STATUS,Z
           goto        m24
           movlw       .9
           goto        Pss

           
m24        movlw       .3           
Pss        movwf       Sec4
           bcf         STATUS,RP0      
me7        movlw       .50
           movwf       Sec0
me5        clrwdt
           movlw       .100
           movwf       Sec
me6        bsf         beep
           call        paus50
           bcf         beep
           call        paus50
           decfsz      Sec,F
           goto        me6
           decfsz      Sec0,F
           goto        me5
           decfsz      Sec4,F
           goto        me7
           return

            End

